<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Staff</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container">
            <div class="row mb-2">
                <div class="col-sm-12 text-center">
                    <h1>Quản trị Hồ sơ Nhân viên</h1>
                </div>

                <div class="mb-3 mt-5">
                    <button class="btn btn-success" id="btn-create-staff">Thêm Mới Staff</button>
                </div>

            </div>
        </div>
        <!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-body">
                            <table class="table table-bordered table-striped table-hover text-center bg-light" id="staff-table">
                                <thead>
                                    <tr>
                                        <th>STT</th>
                                        <th>Mã nhân viên</th>
                                        <th>Tên nhân viên</th>
                                        <th>Chức vụ</th>
                                        <th>Giới tính</th>
                                        <th>Ngày sinh</th>
                                        <th>Địa chỉ</th>
                                        <th>Số điện thoại liên hệ</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>


                            <!-- create staff -->
                            <div class="modal" id="modal-create-staff" tabindex="-1" role="dialog">
                                <div class="modal-dialog" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title">Tạo Hồ sơ Nhân viên mới</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                 <span aria-hidden="true">&times;</span>
                                             </button>
                                        </div>
                                        <div class="modal-body">
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Mã Nhân viên</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-ma-nhan-vien" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Tên Nhân viên</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-ten-nhan-vien" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Chức vụ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-chuc-vu" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Giới tính</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-gioi-tinh" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Ngày sinh</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-ngay-sinh" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Địa chỉ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-create-dia-chi" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Số điện thoại liên hệ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input id="inp-create-so-dien-thoai" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Phòng/Ban</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <select id="select-id-department" class="form-control border-primary">
                                                            <option value="none">--Chọn Phòng/Ban--</option>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-success confirm-create">Tạo mới</button>
                                            <button type="button" class="btn btn-danger cancel-create" data-dismiss="modal">Hủy</button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- update staff -->
                            <div class="modal" id="modal-update-staff" tabindex="-1" role="dialog">
                                <div class="modal-dialog" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title">Cập nhật Hồ sơ Nhân viên</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Mã Nhân viên</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-update-ma-nhan-vien" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Tên Nhân viên</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-update-ten-nhan-vien" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Chức vụ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input type="text" id="inp-update-chuc-vu" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Giới tính</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input id="inp-update-gioi-tinh" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Ngày sinh</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input id="inp-update-ngay-sinh" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Địa chỉ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input id="inp-update-dia-chi" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="row form-group">
                                                    <div class="col-4">
                                                        <label for="" class="font-weight-bold">Số điện thoại liên hệ</label>
                                                    </div>
                                                    <div class="col-8">
                                                        <input id="inp-update-so-dien-thoai" class="form-control">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-success confirm-update">Cập nhật</button>
                                            <button type="button" class="btn btn-danger cancel-update" data-dismiss="modal">Hủy</button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- delete staff -->

                            <div class="modal" tabindex="-1" role="dialog" id="modal-delete-staff">
                                <div class="modal-dialog" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title">Xóa Hồ sơ Nhân viên</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">
                                            <p>Bạn có chắc muốn xóa Hồ sơ nhân viên này?</p>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-primary" id="confirm-delete">Xóa</button>
                                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</body>
<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //định nghĩa table staff
        const gCOLS_ID = 0;
        const gCOLS_MA_NHAN_VIEN = 1;
        const gCOLS_TEN_NHAN_VIEN = 2;
        const gCOLS_CHUC_VU = 3;
        const gCOLS_GIOI_TINH = 4;
        const gCOLS_NGAY_SINH = 5;
        const gCOLS_DIA_CHI = 6;
        const gCOLS_SO_DIEN_THOAI = 7;
        const gCOL_ACTION = 8;


        var gStaffId = 0;
        var gDepartment = [];
        var gDepartmentId = 0;
        const gSTAFF_COL = ["id", "maNhanVien", "tenNhanVien", "chucVu", "gioiTinh", "ngaySinh", "diaChi", "soDienThoai", "action"];
        var gTable = $("#staff-table").DataTable({
            columns: [{
                data: gSTAFF_COL[gCOLS_ID]
            }, {
                data: gSTAFF_COL[gCOLS_MA_NHAN_VIEN]
            }, {
                data: gSTAFF_COL[gCOLS_TEN_NHAN_VIEN]
            }, {
                data: gSTAFF_COL[gCOLS_CHUC_VU]
            }, {
                data: gSTAFF_COL[gCOLS_GIOI_TINH]
            }, {
                data: gSTAFF_COL[gCOLS_NGAY_SINH]
            }, {
                data: gSTAFF_COL[gCOLS_DIA_CHI]
            }, {
                data: gSTAFF_COL[gCOLS_SO_DIEN_THOAI]
            }, {
                data: gSTAFF_COL[gCOL_ACTION]
            }, ],
            columnDefs: [{
                "targets": gCOL_ACTION,
                "defaultContent": `<i class="far fa-edit edit-staff" style= "color : green ; cursor: pointer;" title="Edit" ></i>  
                            <i class="fas fa-trash-alt delete-staff" style= "color : red ; cursor: pointer;" title="Delete"></i>`
            }],
            searching: false,
        });

        onPageLoading();
        //Gán event handler khi click vào hàng bất kỳ trong table staff
        $("#staff-table").on("click", "td", function() {
            onStaffTableRowClick(this);
        });

        // gán sự kiện cho nút add staff
        $("#btn-create-staff").on("click", function() {
            console.log("nút thêm được nhấn!");
            $("#modal-create-staff").modal("show");
            callApiGetAllDepartmentLoadToSelect();
        });
        // confirm staff create
        $(document).on("click", ".confirm-create", function() {
            onBtnCreateStaffClick();
        });
        // cancel staff create
        $(".cancel-create").on("click", function() {
            $("#modal-create-staff").modal("hide");
        });
        $('#select-id-department').on('change', function() {
            onBtnChangeIdSelectDepartment();
        });
        // gán sự kiện cho nút update staff
        $(document).on("click", ".edit-staff", function() {
            $("#modal-update-staff").modal("show");
            onStaffTableRowClick(this);
        });
        $(".confirm-update").on("click", function() {
            onBtnUpdateStaffClick();
        });
        $(".cancel-update").on("click", function() {
            $("#modal-update-staff").modal("hide");
        });

        // gán sự kiện cho nút delete staff
        $(document).on("click", ".delete-staff", function() {
            $("#modal-delete-staff").modal("show");
            onStaffTableRowClick(this);
        });
        // delete department confirm
        $("#confirm-delete").on("click", function() {
            onBtnDeleteStaffClick();
        });


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm load trang
        function onPageLoading() {
            "use strict";
            callApiGetAllStaffShowOnTable();
        }

        function callApiGetAllDepartmentLoadToSelect() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/departments",
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    gDepartment = res;
                    loadDataIntoSelect(gDepartment);
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })

        }

        function loadDataIntoSelect(paramObject) {
            for (var bI = 0; bI < paramObject.length; bI++) {
                $('#select-id-department').append($('<option>', {
                    value: paramObject[bI].id,
                    text: paramObject[bI].tenPhongBan
                }));
            }
        }

        function onBtnChangeIdSelectDepartment() {
            "use strict";
            gDepartmentId = $("#select-id-department").val(); // lấy ra provinceId từ select đc chọn
            console.log("Phòng/Ban được chọn có Id: " + gDepartmentId);
        }
        //Hàm thực thi khi click vào hàng bất kỳ
        function onStaffTableRowClick(paramTableCell) {
            var vClickedRow = $(paramTableCell).parents("tr");
            var vRowData = gTable.row(vClickedRow).data();
            gStaffId = vRowData.id;
            console.log("Đã click vào row có id là: " + gStaffId);
            callAjaxApiGetStaffById(gStaffId);
        }

        //Hàm thực thi khi nhấn nút add staff
        function onBtnCreateStaffClick() {

            var vObj = {
                maNhanVien: $("#inp-create-ma-nhan-vien").val().trim(),
                tenNhanVien: $("#inp-create-ten-nhan-vien").val().trim(),
                chucVu: $("#inp-create-chuc-vu").val().trim(),
                gioiTinh: $("#inp-create-gioi-tinh").val().trim(),
                ngaySinh: $("#inp-create-ngay-sinh").val().trim(),
                diaChi: $("#inp-create-dia-chi").val().trim(),
                soDienThoai: $("#inp-create-so-dien-thoai").val().trim(),
            };

            var vCheck = validateCreateStaffData(vObj);
            if (vCheck == true) {

                $.ajax({
                    url: "http://localhost:8080/department/" + gDepartmentId + "/staff/create",
                    type: "POST",
                    contentType: "application/json",
                    async: false,
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Tạo Hồ sơ Nhân viên mới thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            }

        }

        //Hàm thực thi khi nhấn nút update department
        function onBtnUpdateStaffClick() {
            "use strict";
            if (gStaffId == 0) {
                alert("Hãy click chọn Hồ sơ Nhân viên cần chỉnh sửa!");
            } else {
                var vObj = {
                    maNhanVien: $("#inp-update-ma-nhan-vien").val().trim(),
                    tenNhanVien: $("#inp-update-ten-nhan-vien").val().trim(),
                    chucVu: $("#inp-update-chuc-vu").val().trim(),
                    gioiTinh: $("#inp-update-gioi-tinh").val().trim(),
                    ngaySinh: $("#inp-update-ngay-sinh").val().trim(),
                    diaChi: $("#inp-update-dia-chi").val().trim(),
                    soDienThoai: $("#inp-update-so-dien-thoai").val().trim()
                };
            };
            var vCheck = validateUpdateStaffData(vObj);
            if (vCheck) {
                $.ajax({
                    url: "http://localhost:8080/staffs/update/" + gStaffId,
                    type: "PUT",
                    contentType: "application/json; charset=UTF-8",
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Cập nhật Hồ sơ Nhân viên thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            };
        }


        //Hàm thực thi khi nhấn nút Delete staff
        function onBtnDeleteStaffClick() {
            "use strict";
            console.log("Nút xóa được nhấn!");
            console.log(gStaffId);
            if (gStaffId == 0) {
                alert("Hãy click chọn Hồ sơ nhân viên cần xóa!");
            } else {
                $.ajax({
                    url: "http://localhost:8080/staffs/delete/" + gStaffId,
                    type: "DELETE",
                    dataType: "json",
                    success: function(res) {
                        console.log(res);
                        alert("Xóa Hồ sơ Nhân viên thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.response);
                    }
                });
            }
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm gọi APi lấy ra toàn bộ staff
        function callApiGetAllStaffShowOnTable() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/staffs",
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    gTable.clear();
                    gTable.rows.add(res);
                    gTable.draw();
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })

        }

        //Hàm gọi API để lấy dữ liệu staff theo id
        function callAjaxApiGetStaffById(paramId) {
            $.ajax({
                url: "http://localhost:8080/staffs/" + paramId,
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    loadStaffDataToForm(res);
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })
        }
        //Hàm load dữ liệu department lên form
        function loadStaffDataToForm(paramRes) {
            $("#inp-update-ma-nhan-vien").val(paramRes.maNhanVien);
            $("#inp-update-ten-nhan-vien").val(paramRes.tenNhanVien);
            $("#inp-update-chuc-vu").val(paramRes.chucVu);
            $("#inp-update-gioi-tinh").val(paramRes.gioiTinh);
            $("#inp-update-ngay-sinh").val(paramRes.ngaySinh);
            $("#inp-update-dia-chi").val(paramRes.diaChi);
            $("#inp-update-so-dien-thoai").val(paramRes.soDienThoai);
        }

        //Hàm validate create department
        function validateCreateStaffData(paramObj) {
            "use strict"
            var isSelectDepartment = $("#select-id-department option:selected").val();
            if (paramObj.maNhanVien === "") {
                alert("Hãy nhập mã Nhân viên!");
                return false;
            } else if (paramObj.tenNhanVien === "") {
                alert("Hãy nhập tên Nhân viên!");
                return false;
            } else if (gDepartment = 0 || isSelectDepartment === "none") {
                alert("Hãy chọn Phòng/Ban!");
                return false;
            }
            return true;
        }

        // validate update album
        function validateUpdateStaffData(paramObj) {
            "use strict"
            if (paramObj.maNhanVien === "") {
                alert("Hãy nhập mã nhân viên!");
                return false;
            } else if (paramObj.tenNhanVien === "") {
                alert("Hãy nhập tên nhân viên");
                return false;
            }
            return true;
        }

    });
</script>